<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta charset="utf-8">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/css/bootstrap.min.css">
    <link rel="stylesheet" href="style.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/js/bootstrap.bundle.min.js"></script>
    <title>Document</title>
</head>
<body>
    <div class="register-photo">
        
        <div class="form-container">
            <form action="" id="loginForm">
                <h2 class="text-center" >Create a free account</h2>
                <div class="form-group">
                    <label>Name</label>
                    <input class="form-control" id="inp-name" type="text" name="name" placeholder="Your Name">
                </div>
                <div class="form-group">
                    <label>Email</label>
                    <input class="form-control" type="email"  id="inp-email" name="email" placeholder="Your e-mail address">
                </div>
                <div class="form-group">
                    <label>Password</label>
                    <input class="form-control" id="inp-password" type="password" name="password" placeholder="&#9679;&#9679;&#9679;&#9679;&#9679;">
                </div>
                <div class="form-group">
                    <label>Confirm Password</label>
                    <input class="form-control" id="inp-repassword" type="password" name="password-repeat" placeholder="&#9679;&#9679;&#9679;&#9679;&#9679;">
                </div>
                
                <div class="form-group">
                    <button class="btn btn-success btn-block" type="submit" >
                        Sign Up
                    </button>
                </div>
                <div class="form-group">
                    <p class="form-group">By signing an account, you agree to our 
                        <a href="#" class="text-success">Terms of Use</a> and our 
                        <a href="#" class="text-success">Privacy Policy</a>.
                    </p>
					<hr>
					<p>Already have an account? 
                        <a href="#" class="text-success">Login</a>
                    </p>    
                </div>
                
            </form>
            <div class="image-holder"></div>
        </div>
    </div>
</body>
<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    var gLoginForm = document.getElementById("loginForm");
    gLoginForm.addEventListener("submit", function (e) {
        e.preventDefault(); // Ngăn chặn submit mặc định của form
        // Bước 0: Khởi tạo đối tượng thu thập
        var vObject = {
            name:"",
            email: "",
            password: "",
            confirmpassword:""
        }
        // Bước 1: thu thập dữ liệu
        getDataFromInput(vObject);
        console.log(vObject);
        // Bước 2: Kiểm tra dữ liệu thu thập
        var vCheck = validateData(vObject);
        console.log(vCheck);
        // Bước 3: gọi API xử lý
        if(vCheck == true){
            // create a request
            var vXmlHttpLogin = new XMLHttpRequest();
            processAPI(vXmlHttpLogin, vObject);
            vXmlHttpLogin.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vLoginInfo = vXmlHttpLogin.responseText;                   
                    // Bước 4: hiển thị thông tin
                    displayData(vLoginInfo);
                }
            }
        }
        
    })
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm hiển thị thông tin sau khi đăng nhập
    function displayData(paramInfor){
        "use strict";
        console.log(paramInfor);
    }
    // Hàm xử lý ajax API login
    // Input là đối tượng Request và đối tượng dữ liệu
    function processAPI(paramRequest, paramObject){
        "use strict";
        paramRequest.open("GET", gBASE_URL + "?" + paramObject.toString(), true);
        paramRequest.send();
    }
    // Hàm kiểm tra email
    // Input là email cần kiểm tra
    // Output là true / false
    function validateEmail(email) {
        var re = /\S+@\S+\.\S+/;
        return re.test(email);
    }
    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng dữ liệu cần kiểm tra
    // Output là kết quả true / false
    function validateData(paramObject) {
        "use strict";
        var vResult = true; // Khởi tạo kết quả kiểm tra là đúng
        
        var vName = paramObject.name.trim();
        var vEmail = paramObject.email.trim(); // Chuẩn hóa dữ liệu
        var vPass = paramObject.password.trim();
        var vRePass = paramObject.confirmpassword.trim();

        if ( vName == ""){
            alert("Name is empty");
            vResult = false;
        }
        if (vEmail == "") {
            alert("Email is empty!");
            vResult = false;
        } else {
            if (validateEmail(vEmail) == false) {
                alert("Email is invalid!");
                vResult = false;
            }
        }

        if (vPass == "") {
            alert("Password is empty!");
            vResult = false;
        }
        if(vRePass == "") {
            alert("Can nhap confirm password!");
            vResult = false;
        }

        return vResult;
    }
    // Hàm thu thập dữ liệu
    // Input là đối tượng chứa dữ liệu thu thập
    function getDataFromInput(paramObject) {
        "use strict";

        var vName = document.getElementById("inp-name");
        var vEmail = document.getElementById("inp-email");
        var vPass = document.getElementById("inp-password");
        var vRePass = document.getElementById("inp-repassword")
        
        paramObject.name = vName.value;
        paramObject.email = vEmail.value;
        paramObject.password = vPass.value;
        paramObject.confirmpassword = vRePass.value;
    }
</script>
</html>